require "import"
import "android.widget.*"
import "android.view.*"
import "android.app.*"
import "android.webkit.*"

local activity = activity
local webView
local urlEditText

function onCreate(savedInstanceState)
    activity.setTitle("Simple Browser1.3")
    local layout = LinearLayout(activity)
    layout.setOrientation(1)

    local topLayout = LinearLayout(activity)
    topLayout.setOrientation(0)

    urlEditText = EditText(activity)
    urlEditText.setHint("Enter URL or HTML code")
    topLayout.addView(urlEditText)

    local goButton = Button(activity)
    goButton.setText("Go")
    goButton.setOnClickListener{
        onClick = function(v)
            local input = urlEditText.getText().toString()

            -- Check if the input starts with "<html>" to identify HTML code
            if string.find(input, "^<html>") then
                -- Load the input as HTML content
                webView.loadData(input, "text/html", "UTF-8")
            else
                -- Load the input as a regular URL
                webView.loadUrl(input)
            end
        end
    }
    topLayout.addView(goButton)

    -- Add a refresh button to reload the current page
    local refreshButton = Button(activity)
    refreshButton.setText("Refresh")
    refreshButton.setOnClickListener{
        onClick = function(v)
            webView.reload()
        end
    }
    topLayout.addView(refreshButton)

    -- Add a clear button to reset the URL input
    local clearButton = Button(activity)
    clearButton.setText("Clear")
    clearButton.setOnClickListener{
        onClick = function(v)
            urlEditText.setText("")
        end
    }
    topLayout.addView(clearButton)

    layout.addView(topLayout)

    webView = WebView(activity)
    webView.setWebViewClient(WebViewClient())
    webView.getSettings().setJavaScriptEnabled(true)
    webView.loadUrl("https://www.google.com")
    layout.addView(webView)

    local backButton = Button(activity)
    backButton.setText("Go Back")
    backButton.setOnClickListener{
        onClick = function(v)
            if webView.canGoBack() then
                webView.goBack()
            end
        end
    }
    layout.addView(backButton)

    activity.setContentView(layout)
end